<?php
/* Autor...:  */
/* Esquema.: ALM_CajaChicaItem.xml */
/* Generado: 2020-08-18 04:21:23 */

/* Metodos de acceso a los campos de la tabla ALM_CajaChicaItem */
abstract class BaseALM_CajaChicaItemBN
{
    /* Campos de la tabla */
    private $i_IdCajaDet;    // IdCajaDet: ( no definido )
    private $i_IdSecuencia;    // IdSecuencia: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $f_Cantidad;    // Cantidad: ( no definido )
    private $f_MontoUnitarioConIGV;    // MontoUnitarioConIGV: ( no definido )
    private $f_MontoSubTotal;    // MontoSubTotal: ( no definido )
    private $f_MontoIGV;    // MontoIGV: ( no definido )
    private $f_MontoTotal;    // MontoTotal: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdCajaDet */
    public function setIdCajaDet( $i_IdCajaDet )
    {
        $this->i_IdCajaDet = $i_IdCajaDet;
    }

    /* Obtiene el valor del campo IdCajaDet */
    public function getIdCajaDet()
    {
        return $this->i_IdCajaDet;
    }

    /* Establece el valor del campo IdSecuencia */
    public function setIdSecuencia( $i_IdSecuencia )
    {
        $this->i_IdSecuencia = $i_IdSecuencia;
    }

    /* Obtiene el valor del campo IdSecuencia */
    public function getIdSecuencia()
    {
        return $this->i_IdSecuencia;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Cantidad */
    public function setCantidad( $f_Cantidad )
    {
        $this->f_Cantidad = $f_Cantidad;
    }

    /* Obtiene el valor del campo Cantidad */
    public function getCantidad()
    {
        return $this->f_Cantidad;
    }

    /* Establece el valor del campo MontoUnitarioConIGV */
    public function setMontoUnitarioConIGV( $f_MontoUnitarioConIGV )
    {
        $this->f_MontoUnitarioConIGV = $f_MontoUnitarioConIGV;
    }

    /* Obtiene el valor del campo MontoUnitarioConIGV */
    public function getMontoUnitarioConIGV()
    {
        return $this->f_MontoUnitarioConIGV;
    }

    /* Establece el valor del campo MontoSubTotal */
    public function setMontoSubTotal( $f_MontoSubTotal )
    {
        $this->f_MontoSubTotal = $f_MontoSubTotal;
    }

    /* Obtiene el valor del campo MontoSubTotal */
    public function getMontoSubTotal()
    {
        return $this->f_MontoSubTotal;
    }

    /* Establece el valor del campo MontoIGV */
    public function setMontoIGV( $f_MontoIGV )
    {
        $this->f_MontoIGV = $f_MontoIGV;
    }

    /* Obtiene el valor del campo MontoIGV */
    public function getMontoIGV()
    {
        return $this->f_MontoIGV;
    }

    /* Establece el valor del campo MontoTotal */
    public function setMontoTotal( $f_MontoTotal )
    {
        $this->f_MontoTotal = $f_MontoTotal;
    }

    /* Obtiene el valor del campo MontoTotal */
    public function getMontoTotal()
    {
        return $this->f_MontoTotal;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdCajaDet' => $this->getIdCajaDet(),
            'IdSecuencia' => $this->getIdSecuencia(),
            'IdItem' => $this->getIdItem(),
            'Descripcion' => $this->getDescripcion(),
            'Cantidad' => $this->getCantidad(),
            'MontoUnitarioConIGV' => $this->getMontoUnitarioConIGV(),
            'MontoSubTotal' => $this->getMontoSubTotal(),
            'MontoIGV' => $this->getMontoIGV(),
            'MontoTotal' => $this->getMontoTotal(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_CajaChicaItemBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_CajaChicaItemRs )
    {
        $o_ALM_CajaChicaItemBN = new ALM_CajaChicaItemBN();
        $o_ALM_CajaChicaItemBN->setIdCajaDet( ( integer ) $o_ALM_CajaChicaItemRs[ "IdCajaDet" ] );
        $o_ALM_CajaChicaItemBN->setIdSecuencia( ( integer ) $o_ALM_CajaChicaItemRs[ "IdSecuencia" ] );
        $o_ALM_CajaChicaItemBN->setIdItem( $o_ALM_CajaChicaItemRs[ "IdItem" ] );
        $o_ALM_CajaChicaItemBN->setDescripcion( $o_ALM_CajaChicaItemRs[ "Descripcion" ] );
        $o_ALM_CajaChicaItemBN->setCantidad( ( float ) $o_ALM_CajaChicaItemRs[ "Cantidad" ] );
        $o_ALM_CajaChicaItemBN->setMontoUnitarioConIGV( ( float ) $o_ALM_CajaChicaItemRs[ "MontoUnitarioConIGV" ] );
        $o_ALM_CajaChicaItemBN->setMontoSubTotal( ( float ) $o_ALM_CajaChicaItemRs[ "MontoSubTotal" ] );
        $o_ALM_CajaChicaItemBN->setMontoIGV( ( float ) $o_ALM_CajaChicaItemRs[ "MontoIGV" ] );
        $o_ALM_CajaChicaItemBN->setMontoTotal( ( float ) $o_ALM_CajaChicaItemRs[ "MontoTotal" ] );
        $o_ALM_CajaChicaItemBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_CajaChicaItemRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_CajaChicaItemBN->setUsuarioCreacion( $o_ALM_CajaChicaItemRs[ "UsuarioCreacion" ] );
        $o_ALM_CajaChicaItemBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_CajaChicaItemRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_CajaChicaItemBN->setUsuarioModificacion( $o_ALM_CajaChicaItemRs[ "UsuarioModificacion" ] );
        return $o_ALM_CajaChicaItemBN;
    }
}
?>